#ifndef __config_h
	#define __config_h
	
	// - - - - - - - - - - - - - - - - - - - - 
	// spi configurations
	// - - - - - - - - - - - - - - - - - - - -
	//#define SPI_SOFTWARE
	#define soft_spi_sck portb.7
	#define soft_spi_sdo portb.6
	#define soft_spi_sdi portb.1
	
	#define spi_tris_sck trisb.7
	#define spi_tris_sdo trisb.6
	#define spi_tris_sdi trisb.1
	#define spi_sspcon1 ssp2con1
	#define spi_stat ssp2stat
	#define spi_interrupt_flag SSP2IF
	#define spi_interrupt_reg pir3
	#define spi_buf ssp2buf
	#define spi_port2_conf 	rpinr21=4;  \
							rpinr22=10; \
							rpor10=11;  \
							rpor9=10;
							//assign SDI2 to RP4 (RB1)
							//assign SCK2IN to RP10 (RB7)
							//assign SCK2 to RP10
							//assign SDO2 to RP
							
	//#define SPI_SOFTWARE
	
	// - - - - - - - - - - - - - - - - - - - - 
	// serial port configurations
	// - - - - - - - - - - - - - - - - - - - -
	//configuration for hardware serial port
	#define USE_HARD_SP
	//configuration for software serial port
	//#define USE_SOFT_SP
	//#define soft_serial_pin  portb.5 //software serial port on portb.5
	//#define soft_serial_tris trisb.5 //3 state bit for software serial port
	
	
	// - - - - - - - - - - - - - - - - - - - - 
	// serial ram configurations
	// - - - - - - - - - - - - - - - - - - - -
	//#include "spi.h" //sram uses SPI
	#define sram_no_hold_pin //hold pin is attached to +3.3V and not to the pic
	#define sram_tris_cs   trisa.0
	#define sram_tris_hold 
	#define sram_cs   porta.1=1;porta.0     //chip select active low
	#define sram_hold      //hold active low
	
	//functions needed for SPI transmission/reception, adjust to fit your app
	#define sram_spi_transmit(a) spi_transmit(a)
	#define sram_spi_read() spi_read()
	#define sram_spi_transmit_array(a,b) spi_transmit_array(a,b)
	#define sram_spi_read_array(a,b) spi_read_array(a,b)
	
	// - - - - - - - - - - - - - - - - - - - - 
	// rtc configurations
	// - - - - - - - - - - - - - - - - - - - -
	#define RTC_CLOCK 48000000  //CPU clock freq
	#define RTC_CLOCKS_PER_OVERFLOW 2097152  //number of clocks generated each timer overflow
	#define RTC_TICKS_PER_SECOND 1500000	 //timer count frequency
	#define RTC_ENABLE_TIMER t3con.TMR3ON    //register used to enable the timer
	#define RTC_CLEAR_TIMER tmr3l=0;tmr3h=0; //code used to clear the timer
	#define RTC_INIT_TIMER pie2.TMR3IE=1; t3con.T3CKPS1=1; t3con.T3CKPS0=1; t3con.TMR3CS1=0; t3con.TMR3CS0=0; //code used to init the timer so it can run when RTC_ENABLE_TIMER is set to 1
	#define rtc_timezone 1


#endif