
#ifndef HTTP_H
	#define HTTP_H
	#include <system.h>
	#include <string.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <memory.h>
	#include <rand.h>
	#include <ctype.h>	
	

	#include "stack\stackmain.h"
	#include "sram.h"
	#include "rtc.h"	
	
	#define HTTP_METHOD_SIZE 5 //max length of the HTTP METHOD (GET/POST/HEAD)
	#define HTTP_URL_SIZE 32   //max length of the url/ file requested
	#define HTTP_PAR_SIZE 8    //max length of a http parameter
	#define HTTP_VAL_SIZE 24   //max length of a http parameter value
	#define HTTP_MAX_PAR 8    //max number of paramters in 1 request
	#define HTTP_MAX_REQUEST 1 //max number of request at one time
	#define HTTP_MAX_HEADER_SIZE 64 //max size of a header line
	
	
	typedef struct {
		unsigned char name[HTTP_PAR_SIZE];
		unsigned char val[HTTP_VAL_SIZE];
	}HTTPParameter;
	
	void HTTPInitServer(unsigned int port);
	void HTTPTask();
	unsigned char HTTPParseRequest(unsigned char *str,unsigned char * method, unsigned char * file,HTTPParameter * pars, unsigned char argc);
	unsigned char * ParseSpace(unsigned char *str);
	unsigned char * ParseString(unsigned char * str, unsigned char * dst, unsigned char * delim, size_type dstlen);
	unsigned char * ParseHTTPParameter(unsigned char * str, HTTPParameter * par);
	
	
	//client definitions
	#define HTTP_DOWNLOAD_TIMEOUT 120 //max 120 sec. wait before download fails
	#define HTTP_MAX_SERVER_SIZE 32 //max size of the servername in an url (this includes the wwww.)
	
	typedef struct {
		unsigned char respons; //returns the respons from the server
		unsigned int headerstart; //start of the header
		unsigned int headerlen; //length of the header (in bytes) including the empty line
		unsigned int filesize; //length of the content of the file (the file starts at headerstart+headerlen)
	}HTTPRespons;
	
	
	bool HTTPDownloadFile(unsigned char * url, unsigned char * method, HTTPRespons * result); //downloads an url, returns true when server responded with HTTP/*.* 200 OK
	//unsigned int HTTPDownloadFile(unsigned char * url, unsigned int headers, unsigned int * headerlen, HTTPRespons * result); //downloads a file with optional headers added stored in sram at location: headers
	
#endif