

#include "rtc.h"
//init rtc

unsigned long rtc_overflows;
unsigned long rtc_time;
unsigned char rtc_ticks[6];

void rtc_init(){
	rtc_overflows=0;
	rtc_time=0;
	rtc_ticks[0]=0;
	rtc_ticks[1]=0;
	rtc_ticks[2]=0;
	rtc_ticks[3]=0;
	rtc_ticks[4]=0;
	rtc_ticks[5]=0;
	RTC_CLEAR_TIMER
	RTC_INIT_TIMER
	RTC_ENABLE_TIMER=1;
}

void rtc_get_tick_copy(){
	rtc_ticks[0] = tmr3l;
	rtc_ticks[1] = tmr3h;
}

unsigned long rtc_get_tick(){
	rtc_get_tick_copy();
	return *((unsigned long*)& rtc_ticks[0]);
}

unsigned long rtc_get_tick_div256(){
	rtc_get_tick_copy();
	return *((unsigned long*)& rtc_ticks[1]);
}

unsigned long  rtc_get_tick_64k(){
	rtc_get_tick_copy();
	return (unsigned long)rtc_ticks[2];
}

void rtc_handle_timer(){
	(*((unsigned long*)&rtc_ticks[2]))++;
	rtc_ticks[0] = tmr3l;
	rtc_ticks[1] = tmr3h;
	rtc_overflows+=RTC_CLOCKS_PER_OVERFLOW;
	while (rtc_overflows >= RTC_CLOCK){
		rtc_time++;
		rtc_overflows -= RTC_CLOCK;
	}
}

unsigned long rtc_get_time(){
	return rtc_time;
}

unsigned char rtc_get_hour(){
	return ((rtc_time / 3600)+rtc_timezone) % 24;
}

unsigned char rtc_get_min(){
	return (rtc_time / 60) % 60;
}

unsigned char rtc_get_sec(){
	return rtc_time % 60;
}

inline void rtc_set_time(unsigned long seconds){
	RTC_ENABLE_TIMER=0;
	rtc_overflows=0;
	rtc_time=seconds;
	RTC_CLEAR_TIMER
	RTC_ENABLE_TIMER=1;
}

//add code that can sync the clock (with sntp)
bool rtc_download_time(){					

}