//handles timer interrupts,... to generate a realtime clock

//before including define:

/*
#define RTC_CLOCK 48000000  //CPU clock freq
#define RTC_CLOCKS_PER_OVERFLOW 2097152 //number of clocks generated each timer overflow
#define RTC_ENABLE_TIMER t3con.TMR3ON //register used to enable the timer
#define RTC_CLEAR_TIMER tmr3l=0;tmr3h=0; //code used to clear the timer
#define RTC_INIT_TIMER pie2.TMR3IE=1; t3con.T3CKPS1=1; t3con.T3CKPS0=1; t3con.TMR3CS=0; //code used to init the timer so it can run when RTC_ENABLE_TIMER is set to 1
*/

#ifndef _REALTIMECLOCK_H
	#define _REALTIMECLOCK_H
	#include <system.h>
	#include "config.h"

	void rtc_init(); //init the clock (keeps seconds since 1970 and nr of clock ticks since restart)
	void rtc_handle_timer(); //should be called in the intterupt routine
	unsigned long rtc_get_time(); //returns seconds since start or 1970
	unsigned char rtc_get_hour(); //returns the hour digit
	unsigned char rtc_get_min(); //returns the min. digit
	unsigned char rtc_get_sec(); //returns seconds digit
	void rtc_set_time(unsigned long seconds); //sets the time
	bool rtc_download_time(); //function used to download the time (not supported yet)
	unsigned long rtc_get_tick();
	unsigned long rtc_get_tick_div256();
	unsigned long  rtc_get_tick_64k();


#endif