#include "spi.h"
	
	void spi_init(){
		//analog inputs must be turned off!
		spi_tris_sdi=1; //input
		spi_tris_sdo=0; //output
		spi_tris_sck=0; //output
		
		#ifdef SPI_SOFTWARE
			soft_spi_sdo=0;
			soft_spi_sck=0;
		#else	
			spi_port2_conf;

			
			spi_tris_sck=0; //output
			spi_tris_sdo=0; //output
			spi_tris_sdi=1; //input				
			
			soft_spi_sck=0;
			soft_spi_sdo=0;
			
			spi_stat.SMP=0; //sample at the middle
			spi_stat.CKE=1; //transmit data on rising edge
			spi_sspcon1.CKP=0; //clock polarity: idle is low 
			
			spi_sspcon1.SSPM3=1;
			spi_sspcon1.SSPM2=0;
			spi_sspcon1.SSPM1=1; // speed: 48/4 MHz
			spi_sspcon1.SSPM0=0;
			
			spi_sspcon1.SSPEN=1; //enable SPI
		#endif
	}

	#ifdef SPI_SOFTWARE
		void spi_transmit(unsigned char byte){
			for (unsigned char i=0;i<8;i++){
				soft_spi_sck=0;
				soft_spi_sdo=byte.7;
				byte = byte << 1;
				soft_spi_sck=1;
			}
			soft_spi_sck=0;
		}	
	#else
		void spi_transmit(unsigned char data){
			clear_bit(spi_interrupt_reg, spi_interrupt_flag);
			spi_buf = data;
			while (!test_bit(spi_interrupt_reg, spi_interrupt_flag));
			unsigned char dummy = spi_buf;
		}
	#endif

	
	void spi_transmit_array(unsigned char * bytes, unsigned int count){
		for (unsigned int i=0;i<count;i++)
			spi_transmit(bytes[i]);
	}
	
	void spi_transmit_string(unsigned char * string){
		spi_transmit_array(string,strlen(string));
	}
	
	#ifdef SPI_SOFTWARE
		unsigned char spi_read(){
			unsigned char res=0;
			soft_spi_sck=0;
			for (unsigned char i=0;i<8;i++){
				soft_spi_sck=1;
				res = res << 1;
				res.0=soft_spi_sdi; //read bit
				soft_spi_sck=0;
			}
			return res;
		}
	#else
		unsigned char spi_read(){
			clear_bit(spi_interrupt_reg,spi_interrupt_flag);
			spi_buf = 0;
			while (!test_bit(spi_interrupt_reg,spi_interrupt_flag));
			return spi_buf;
		}
	#endif
	
	unsigned int spi_read_array(unsigned char * array, unsigned int count){
		if (array!=NULL){
			for (unsigned int i=0;i<count;i++)
				array[(size_type)i]=spi_read();
		}else{
			for (unsigned int i=0;i<count;i++) spi_read();
		}
		return count;
	}