
#ifndef _STACKDEFS_H_
	#define _STACKDEFS_H_
//some general definitions,... needed for MC TCP/IP stack

#define WORD unsigned int
#define BYTE unsigned char
#define BOOL bool
#define DWORD unsigned long
#define TRUE true
#define FALSE false
#define BOOL8 unsigned char
#define PTR_BASE unsigned int //defines the size of a SPI RAM PTR
#define SHORT signed int
#define LONG signed long
#define NetBIOSSize 16

typedef union{
	WORD Val;
    BYTE v[2];
    struct {
        BYTE LB;
        BYTE HB;
    } byte;
}WORD_VAL;

typedef union {
    DWORD Val;
    WORD w[2];
    BYTE v[4];
    struct{
        WORD LW;
        WORD HW;
    } word;
    struct {
        BYTE LB;
        BYTE HB;
        BYTE UB;
        BYTE MB;
    } byte;
    struct {
        WORD_VAL low;
        WORD_VAL high;
    }wordUnion;
}DWORD_VAL;


typedef struct{
	unsigned char v[6];
} MAC_ADDR;

// Definition to represent an IP address
#define IP_ADDR		DWORD_VAL

// Address structure for a node
typedef struct {
    IP_ADDR     IPAddr;
    MAC_ADDR    MACAddr;
} NODE_INFO;

// Application-dependent structure used to contain address information
typedef struct {
	IP_ADDR		IPV4Addr;               // IP address
	IP_ADDR		Mask;                   // Subnet mask
	IP_ADDR		Gateway;                // Default Gateway
	IP_ADDR		PrimaryDNSServer;       // Primary DNS Server
	IP_ADDR		SecondaryDNSServer;     // Secondary DNS Server
	IP_ADDR		DefaultIPAddr;          // Default IP address
	IP_ADDR		DefaultMask;            // Default subnet mask
	unsigned char NetBIOSName[NetBIOSSize];      // NetBIOS name
	struct {
		BOOL8 bIsDHCPEnabled;
		BOOL8 bInConfigMode;
	} Flags;                            // Flag structure
}IPV4_CONFIG; //APP_CONFIG

//receive header of ethernet packet (produced by ENC28J60)
typedef struct{
    unsigned int    NextPacketPointer;
    unsigned char   StatusVector[4];//unsigned char   StatusVector[7];
    MAC_ADDR        DestMACAddr;
    MAC_ADDR        SourceMACAddr;
    unsigned int    Type;
} ENC_PREAMBLE;

typedef struct {
	MAC_ADDR        DestMACAddr;
	MAC_ADDR        SourceMACAddr;
	WORD_VAL        Type;
} ETHER_HEADER;

#endif