
/* generates some common functions */

#include "stackmain.h"

IPV4_CONFIG IPNetworkConfig; //configuration for the IP network

void network_set_ip (IP_ADDR *ip){
	IPNetworkConfig.IPV4Addr = *ip;
}

void network_set_defaultip(IP_ADDR * ip){
	IPNetworkConfig.DefaultIPAddr=*ip;
}

void network_set_defaultsubnet (IP_ADDR * subnet){
	IPNetworkConfig.DefaultMask=*subnet;  
}

void network_set_subnet (IP_ADDR * subnet){
	IPNetworkConfig.Mask=*subnet; 
}

void network_set_gateway(IP_ADDR * gateway){
	IPNetworkConfig.Gateway=*gateway;
}

void network_set_dns (IP_ADDR * primarydns, IP_ADDR * secondaydns){
	IPNetworkConfig.PrimaryDNSServer = *primarydns;       // Primary DNS Server
	IPNetworkConfig.SecondaryDNSServer = *secondaydns;     // Secondary DNS Server	
}

void network_set_netBIOSname(unsigned char * netBIOSName){
	strcpy(IPNetworkConfig.NetBIOSName,netBIOSName);
	FormatNetBIOSName(IPNetworkConfig.NetBIOSName);
}

void network_set_dhcp (bool Enabled){
	IPNetworkConfig.Flags.bIsDHCPEnabled = Enabled ? true:false;
}

void network_set_configmode(bool inConfigMode){
	IPNetworkConfig.Flags.bInConfigMode=inConfigMode;
}

bool network_in_configmode (){
	return IPNetworkConfig.Flags.bInConfigMode ==true;
}

bool network_dhcp_enabled(){
	return IPNetworkConfig.Flags.bIsDHCPEnabled==true;
}

IP_ADDR network_get_primary_dns (){
	return IPNetworkConfig.PrimaryDNSServer;
}

IP_ADDR network_get_secondary_dns(){
	return IPNetworkConfig.SecondaryDNSServer;
}

IP_ADDR network_get_ip(){
	return IPNetworkConfig.IPV4Addr;
}

IP_ADDR network_get_subnet(){
	return IPNetworkConfig.Mask;
}

IP_ADDR network_get_gateway(){
	return IPNetworkConfig.Gateway;
}

MAC_ADDR network_get_mac(){
	return *MACGetAddress();
}

unsigned char * network_get_netBIOSname(){
	return & IPNetworkConfig.NetBIOSName;
}

void network_init(MAC_ADDR * mac, IPV4_CONFIG * IPConfig){
	MACSetAddress(mac);
	IPNetworkConfig=*IPConfig;
	StackInit(); //in stacktask we init the TCP/IP stack
}

void network_handle_tasks(){
	StackTask();
	StackApplications();
}

