
//this is the main include file for all TCP,UDP/IP stack applications
//include this file in your main project .c file and all other files that use the stack
#ifndef _STACK_MAIN_H

	#define _STACK_MAIN_H
	#include <system.h>
	#include <string.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <memory.h>
	#include <rand.h>
	#include <ctype.h>	
	#include "stackconf.h"
	#include "stackdefs.h"
	#include "Helpers.h"

	void network_set_ip (IP_ADDR *ip);
	void network_set_defaultip(IP_ADDR * ip);
	void network_set_defaultsubnet (IP_ADDR * subnet);
	void network_set_subnet (IP_ADDR * subnet);
	void network_set_gateway(IP_ADDR * gateway);
	void network_set_dns (IP_ADDR * primarydns, IP_ADDR * secondaydns);
	void network_set_netBIOSname(unsigned char * netBIOSName);
	void network_set_dhcp (bool Enabled);
	void network_set_configmode(bool inConfigMode);
	bool network_in_configmode();
	bool network_dhcp_enabled();
	IP_ADDR network_get_ip();
	IP_ADDR network_get_subnet();
	IP_ADDR network_get_gateway();
	MAC_ADDR network_get_mac();
	IP_ADDR network_get_primary_dns ();
	IP_ADDR network_get_secondary_dns();
	unsigned char * network_get_netBIOSname();
	void network_init(MAC_ADDR * mac, IPV4_CONFIG * IPConfig);
	void network_handle_tasks();
	
	#ifdef ETH_ENC28J60
		#include "eth\ENC28J60.h"
	#endif
	
	#ifdef STACK_USE_IP
		#include "IP.h"
		#include "ARP.h"
		#ifdef STACK_USE_ICMP
			#include "ICMP.h"
		#endif
		#ifdef STACK_USE_UDP
			#include "UDP.h"
		#endif
		#ifdef STACK_USE_DHCP_CLIENT
			#include "DHCP.h"
		#endif
		#ifdef STACK_USE_DNS
			#include "DNS.h"
		#endif
		#ifdef STACK_USE_DYNAMICDNS_CLIENT
			#include "DynDNS.h"
		#endif
		#ifdef STACK_USE_NBNS
			#include "nbns.h"
		#endif
		#ifdef STACK_USE_TCP
			#include "TCP.h"
		#endif
	#endif

	#include "stacktask.h"
	
#endif